require "httparty"
require "delegate"
require "recursive-open-struct"

require "SelfPay/version"
require "SelfPay/auth/basic"
require "SelfPay/resource/billet"
require "SelfPay/api"
require "SelfPay/response"
require "SelfPay/client"
require "SelfPay/connect_client"
require "SelfPay/billet_api"

require "SelfPay/exceptions/invalid_enviroment_error"
require "SelfPay/util/filters_encoder"

module SelfPay
  class Error < StandardError; end
  class << self
    VALID_ENVS = %i(sandbox production).freeze

    def env=(env)
      raise InvalidEnviromentError unless VALID_ENVS.include?(env.to_sym)
      @env = env
    end

    def env
      @env ||= :sandbox
    end

    def auth=(credentials)
      @credentials = credentials
    end

    def auth
      @credentials
    end

    def opts=(opts = {})
      @opts = opts
    end

    def opts
      @opts ||= {}
    end

    def new
      raise "Auth is not set" unless auth
      Api.new Client.new(env, auth)
    end
  end
end
