module SelfPay
  module Resource
    class Billet < SimpleDelegator
      attr_reader :client, :payment_api, :external_id

      def initialize(client, response)
        super(response)
        @client = client

        if response.respond_to?(:external_id)
          @billet_api = BilletApi.new(client)
          @external_id = response.external_id
        end
      end

      def create_billet(billet)
        billet_api.create(billet)
      end
    end
  end
end
